{
Abstract:     
Author:  Prof1983 <prof1983@yandex.ru>
Created: 06.03.2008
LastMod: 09.06.2011
Version: 0.3.1
}
unit ASettings03;

interface

uses
  ABase0, ARuntime0, ASettings0, ASettings, ASettingsExp;

{ Protected }

function Settings_Boot: AInteger; stdcall;
function Settings_Init: AInteger; stdcall;
function Settings_Done: AInteger; stdcall;

implementation

const
  SettingsProcs: ASettingsProcs_Type = (
    Close: A_Settings_Close;
    DeleteKeyW: Settings_DeleteKey;
    DeleteSectionW: Settings_DeleteSection;
    IniConfig_NewW: Settings_IniConfig_New;
    ReadBoolW: Settings_ReadBool;
    ReadIntegerW: Settings_ReadInteger;
    ReadFloatW: Settings_ReadFloat;
    ReadSectionW: Settings_ReadSection;
    ReadStringW: Settings_ReadString;
    ReadDateTimeW: Settings_ReadDateTime;
    RegConfig_NewW: Settings_RegConfig_New;
    RegConfig_NewAW: Settings_RegConfig_NewA;
    WriteBoolW: Settings_WriteBool;
    WriteIntegerW: Settings_WriteInteger;
    WriteFloatW: Settings_WriteFloat;
    WriteStringW: Settings_WriteString;
    WriteDateTimeW: Settings_WriteDateTime;

    DeleteKey: A_Settings_DeleteKey;
    DeleteSection: A_Settings_DeleteSection;
    IniConfig_New: A_Settings_IniConfig_New;
    ReadBool: A_Settings_ReadBool;
    ReadInteger: A_Settings_ReadInteger;
    ReadFloat: A_Settings_ReadFloat;
    ReadSection: A_Settings_ReadSection;
    ReadString: A_Settings_ReadString;
    ReadDateTime: A_Settings_ReadDateTime;
    RegConfig_New: A_Settings_RegConfig_New;
    RegConfig_NewA: A_Settings_RegConfig_NewA;
    WriteBool: A_Settings_WriteBool;
    WriteInteger: A_Settings_WriteInteger;
    WriteFloat: A_Settings_WriteFloat;
    WriteString: A_Settings_WriteString;
    WriteDateTime: A_Settings_WriteDateTime;

    Reserved33: 0;
    Reserved34: 0;
    Reserved35: 0;
    Reserved36: 0;
    Reserved37: 0;
    Reserved38: 0;
    Reserved39: 0;
    Reserved40: 0;
    Reserved41: 0;
    Reserved42: 0;
    Reserved43: 0;
    Reserved44: 0;
    Reserved45: 0;
    Reserved46: 0;
    Reserved47: 0;
    Reserved48: 0;
    Reserved49: 0;
    Reserved50: 0;
    Reserved51: 0;
    Reserved52: 0;
    Reserved53: 0;
    Reserved54: 0;
    Reserved55: 0;
    Reserved56: 0;
    Reserved57: 0;
    Reserved58: 0;
    Reserved59: 0;
    Reserved60: 0;
    Reserved61: 0;
    Reserved62: 0;
    Reserved63: 0;
    );

const
  Module: AModule_Type = (
    Version: ASettings_Version;
    Uid: ASettings_Uid;
    Name: ASettings_Name;
    Description: nil;
    Init: Settings_Init;
    Done: Settings_Done;
    Reserved06: 0;
    Procs: Addr(SettingsProcs);
    );

var
  FInitialized: Boolean;

{ Module_Settings }

function Settings_Boot: AInteger; stdcall;
begin
  Settings_SetProcs(Addr(Settings));
  Result := ARuntime.Module_Register(Addr(Module));
end;

function Settings_Done: AInteger; stdcall;
begin
  Result := 0;
end;

function Settings_Init: AInteger; stdcall;
begin
  if FInitialized then
  begin
    Result := 0;
    Exit;
  end;

  FInitialized := True;
  Result := 0;
end;

initialization
  Settings_SetProcs(Addr(SettingsProcs));
end.
